//***********************************************************************************
//	export.h
//	High Tech BASIC, Copyright (C) TransEra Corp 1987 - 2002, All Rights Reserved.
//***********************************************************************************

#ifndef __EXPORT_H
#define __EXPORT_H

#ifndef DLLEXPORT
#define DLLEXPORT __declspec(dllimport)

	// If this file is being used in a DLL that does not use the Windows definitions, then
	// define this so the Windows-type variables wont cause the compiler to generate
	// "undefined type" errors.
	#ifndef	_WINDLL
	#define WINDOWS_NOT_DEFINED
	#endif	// not a windows DLL

#endif	// DLLEXPORT not defined



//**********************************************************************************
// events used for SetExportFunction

#define L_BTN_DOWN		0	// CPoint *
#define L_BTN_UP		1	// CPoint *
#define R_BTN_DOWN		2	// CPoint *
#define R_BTN_UP		3	// CPoint *
#define M_BTN_DOWN		4	// CPoint *
#define M_BTN_UP		5	// CPoint *
#define MOUSE_MOVE		6	// CPoint *
#define CLEAR_SCREEN	7	// NULL
#define ON_DRAW			8	// HDC

//***********************************************************************************

extern "C"
{

//***********************************************************************************
// Non-Windows Prototypes
DLLEXPORT void Disp(char * pMsg, bool bOption = true);	// print string on display line
DLLEXPORT int Signal(int SignalNum);					// exported SIGNAL Statement
DLLEXPORT bool CheckInt();								// check for basic clear i/o or reset
DLLEXPORT int PutBuffer(void * pIOPath, char * pData, bool bOption = false);	// place null terminated string into buffer
DLLEXPORT int GetBuffer(void * pIOPath, char * pData, long Length);		// read string data from buffer
DLLEXPORT void Interactive(bool bOption);				// see HTBasic Suspend Interactive and resume interactive command
DLLEXPORT void RefreshScreen();
// end Non-Windows prototypes
//***********************************************************************************


#ifndef	WINDOWS_NOT_DEFINED		// These variables and functions must have all the windows definitions to be valid.
//***********************************************************************************
// Windows Variables
extern DLLEXPORT HWND g_hBasicWindow;				// exported global WINDOW HANDLE
extern DLLEXPORT HWND g_hBasicFrameWindow;			// exported global WINDOW HANDLE
extern DLLEXPORT HCURSOR g_hBasicCursor;			// exported global POINTER TO CURSOR HANDLE
// end Windows Variables
//**********************************************************************
// Windows Prototypes
DLLEXPORT void GetBasicEvents(LPHANDLE ResetEvent, LPHANDLE ShutdownEvent);	// Basic events for reset and shutdown
DLLEXPORT void Registerthread(LPHANDLE phEvent);	// register event so Basic will wait on shutdown
DLLEXPORT void Unregisterthread(LPHANDLE phEvent);	// call this to unregister your thread
DLLEXPORT CWinApp * GetBasicApp();					// get pointer to basic app
DLLEXPORT void SetBasicCursor(char * pCursor);		// set standard cursors
DLLEXPORT void SetExportFunction(USHORT Event,void * pFunction);	// hand Basic a function to call on an event
// The following function should only be called from the basic thread.
DLLEXPORT HBITMAP GetBasicBitmapHandle();			// get handle to the basic window bitmap
// end Windows prototypes
//***********************************************************************************

#endif	// WINDOWS_NOT_DEFINED

}	// end extern "C"

#endif // ifndef-define __EXPORT_H
